package com.vendor.burn.model.badcheck;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.model.badcheck.BadBlockModel;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Layout;

public class BadBlockComposite extends Composite {
  private BadBlockModel badBlock = new BadBlockModel();
  
  public BadBlockComposite(Composite parent, int style) {
    super(parent, style);
    setLayout((Layout)new GridLayout(1, false));
    createContents(this);
  }
  
  private void createContents(Composite parent) {
    parent.setBackground(Display.getCurrent().getSystemColor(15));
    parent.addPaintListener((PaintListener)new Object(this));
  }
  
  protected void handlePaint(PaintEvent e) {
    Composite control = (Composite)e.widget;
    GC gc = e.gc;
    int bottomY = (control.getSize()).y;
    int margin = 4;
    int clientAreaX = (control.getSize()).x - margin;
    gc.setBackground(Display.getDefault().getSystemColor(5));
    gc.fillRectangle(control.getClientArea());
    gc.setForeground(Display.getCurrent().getSystemColor(3));
    float[] indexes = new float[(getBadBlock().getBadAddress()).length];
    int[] xOffset = new int[(getBadBlock().getBadAddress()).length];
    int block = getBadBlock().getBlock();
    for (int i = 0; i < (getBadBlock().getBadAddress()).length; i++) {
      long address = getBadBlock().getBadAddress()[i];
      if (address % block != 0L) {
        indexes[i] = (float)address / (block + 1);
      } else {
        indexes[i] = (float)address / block;
      } 
      double percent = indexes[i] * 1.0D / getBadBlock().getChip() / block;
      xOffset[i] = (int)(percent * clientAreaX);
      if (i + 1 < xOffset.length && 
        xOffset[i] != xOffset[i + 1])
        gc.drawLine(xOffset[i], 0, xOffset[i], bottomY); 
      gc.drawLine(xOffset[i], 0, xOffset[i], bottomY);
    } 
  }
  
  public BadBlockModel getBadBlock() {
    return this.badBlock;
  }
}
